

def scope():

    def code_mul48():
        nohop()
        # Fixed point multiply for number in 4+8 format:
        # 4 bits for the integral part and 8 bits for the fractional part.
        # Positive numbers have the upper four bits set to zero.
        # Negative numbers have the upper four bits set to one.
        # Overflow silently gives an incorrect result. 
        #
        # Register usage:
        # R8 : A
        # R9 : B
        # R10: product
        # R11: bit
        # R12: B<<3
        
        label('mul48')
        LDWI('SYS_LSRW1_48');STW('sysFn')
        # vars: A:R8, B:R9, C:R10, bit:R11, sgn:R12
        LDI(0);STW(R10);STW(R12)
        LDI(1);STW(R11)
        # sign
        LDW(R8);BGE('.s0')
        LDI(0);SUBW(R8);INC(R12);STW(R8)
        label('.s0')
        LDW(R9);BGE('.s1')
        LDI(0);SUBW(R9);INC(R12)
        label('.s1')
        LSLW();LSLW();LSLW();STW(R9)
        # mul
        label('.mul1')
        LDW(R11);ANDW(R8);BEQ('.mul2')
        LDW(R9)
        label('.mul2')
        ADDW(R10);STW(R10)
        LDW(R11);LSLW();STW(R11)
        LD(vACH);XORI(0x10);BEQ('.s2')
        LDW(R10);SYS(48);STW(R10)
        BRA('.mul1')
        # apply sign
        label('.s2')
        LD(R12);ANDI(1);BEQ('.s3')
        LDI(0);SUBW(R10);RET()
        label('.s3')
        LDW(R10);RET()
        
    module(name='fix48.s',
           code=[('EXPORT', 'mul48'),
                 ('CODE',  'mul48', code_mul48) ] )


scope()

# Local Variables:
# mode: python
# indent-tabs-mode: ()
# End:
