#include <stdlib.h>
#include <stdio.h>
#include <math.h>

#include "fix48.h"

//#define SPEC_B 0x826
//#define SPEC_A 0x1f1
//#define EXHAUSTIVE 1


#if defined(SPEC_A) && defined(SPEC_B)

void main()
{
  fix48 a = SPEC_A;
  fix48 b = SPEC_B;
  fix48 ab = mul48(a,b);
  printf("%04x %04x -> %04x\n", a, b, ab);
}

#elif EXHAUSTIVE

void main()
{
  fix48 a, b, xab, yab;
  float fa, fb, fab;
  /* positive only. does not test sign. */
  for (a=FIX48(0); a<FIX48(16); a+=17)
    for (b=FIX48(0); b<FIX48(16); b+=17) {
      fa = FIX48_TO_FLT(a);
      fb = FIX48_TO_FLT(b);
      fab = fa * fb;
      if (fab <= -16 || fab >= 16)
        continue;
      xab = mul48(a,b);
      yab = FIX48(fab);
      if (xab != yab)
        printf("A = %04x (%.3f)\tB = %04x (%.3f) \n"
               "\tA*B=%04x (%.3f) != %04x (%.3f)\n",
               a, fa, b, fb,
               xab, FIX48_TO_FLT(xab),
               yab, fab);
    }
  printf("Done\n");
}

#else

float readnum(const char *msg)
{
  char buffer[40];
  char *s = 0;
  while(!*s) {
    printf("%s",msg);
    s = fgets(buffer, sizeof(buffer), stdin);
    if (feof(stdin))
      abort();
  }
  return strtod(s, NULL);
}

void main()
{
  for(;;) {
    double fa, fb;
    fix48 a, b, ab;
    printf("------------\n");
    fa = readnum("A=");
    fb = readnum("B=");
    printf("(flt) A=%.3f, B=%.3f A*B=%.3f\n",
           fa, fb, fa * fb);
    a = FIX48(fa);
    b = FIX48(fb);
    ab = mul48(a,b);
    printf("(fix) a=%04x (%.3f), b=%04x (%.3f), A*B=%04x (%.3f)\n",
           a, FIX48_TO_FLT(a),
           b, FIX48_TO_FLT(b),
           ab, FIX48_TO_FLT(ab) );
  }
}

#endif

/* Local Variables: */
/* mode: c */
/* c-basic-offset: 2 */
/* indent-tabs-mode: () */
/* End: */
